# Module

open class Module : XmlPersistableConfigurationObject

Represents the customizable elements of an iml (via XML hooks everything of the iml is customizable).

## Constructors

Module
Link copied to clipboard
constructor(withXmlActions: XmlTransformer, pathFactory: PathFactory)

## Properties

contentPath
Link copied to clipboard
open var contentPath: Path
dependencies
Link copied to clipboard
open var dependencies: Set<Dependency>
excludeFolders
Link copied to clipboard
open var excludeFolders: Set<Path>
generatedSourceFolders
Link copied to clipboard
open var generatedSourceFolders: Set<Path>
INHERITED
Link copied to clipboard
val INHERITED: String = "inherited"
jdkName
Link copied to clipboard
open var jdkName: String
outputDir
Link copied to clipboard
open var outputDir: Path
resourceFolders
Link copied to clipboard
open var resourceFolders: Set<Path>
sourceFolders
Link copied to clipboard
open var sourceFolders: Set<Path>
testOutputDir
Link copied to clipboard
open var testOutputDir: Path
testResourceFolders
Link copied to clipboard
open var testResourceFolders: Set<Path>
testSourceFolders
Link copied to clipboard
open var testSourceFolders: Set<Path>
xml
Link copied to clipboard
open val xml: Node

## Functions

equals
Link copied to clipboard
open fun equals(o: Any): Boolean
findFirstChildNamed
Link copied to clipboard
open fun findFirstChildNamed(root: @Nullable Node, name: String): @Nullable Node
findFirstChildWithAttributeValue
Link copied to clipboard
open fun findFirstChildWithAttributeValue(root: @Nullable Node, childName: String, attribute: String, value: String): @Nullable Node
findOrCreateFirstChildNamed
Link copied to clipboard
open fun findOrCreateFirstChildNamed(root: Node, name: String): Node
findOrCreateFirstChildWithAttributeValue
Link copied to clipboard
open fun findOrCreateFirstChildWithAttributeValue(root: @Nullable Node, childName: String, attribute: String, value: String): Node
hashCode
Link copied to clipboard
open fun hashCode(): Int
isInheritOutputDirs
Link copied to clipboard
open fun isInheritOutputDirs(): Boolean
If true, output directories for this module will be located below the output directory for the project; otherwise, outputDir and testOutputDir will take effect.
load
Link copied to clipboard
open fun load(inputStream: InputStream)
loadDefaults
Link copied to clipboard
open fun loadDefaults()
setInheritOutputDirs
Link copied to clipboard
open fun setInheritOutputDirs(inheritOutputDirs: Boolean)
store
Link copied to clipboard
open fun store(outputStream: OutputStream)
toString
Link copied to clipboard
open fun toString(): String
transformAction
Link copied to clipboard
open fun transformAction(action: Closure)